//       
//         
//     
//       
//  
#include <ChartObjects\ChartObjectsLines.mqh>//       
#include <Trade\SymbolInfo.mqh>//      
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_plots   1
//--- plot CumIkviti
#property indicator_label1  "CumIkviti"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- input parameters
input string   Symb1="EURUSD";
input string   Symb2="GBPUSD";
input string   Symb3="USDJPY";
input string   Symb4="NONE";
input string   Symb5="NONE";
input string   Symb6="NONE";
input string   Symb7="NONE";
input string   Symb8="NONE";
input string   Symb9="NONE";
input string   Symb10="NONE";
double   CumIkvitiBuffer[];// 
double   cumikviti[];//  
datetime oldstart;//    
datetime oldstop;//    
bool  objdrag;//    
bool  dragen;//    
struct sInstrum
  {//    
   string   Name;// 
   datetime start;//    
   datetime stop;//     
   double   ikviti[];//  
   double   open[];//       
   double   k;//    
   double   cost;//     
   double   startopen;//         
  };
MqlRates rates[];
sInstrum  Instrum[];//  
CChartObjectVLine line;
CSymbolInfo symb;
int OnInit()
  {
   objdrag=false ;
   dragen=true;
   CopyRates(Symbol(),0,1,1,rates) ;//    
   oldstop=rates[0].time;// 
   ObjectCreate(0,"Stop",OBJ_VLINE,0,oldstop,0) ; //     
   ObjectSetInteger(0,"Stop",OBJPROP_COLOR,Red) ;//     
   ObjectSetInteger(0,"Stop",OBJPROP_SELECTABLE,true) ;
   //------------------------------------------------------
   CopyRates(Symbol(),0,20,1,rates);//  20-  
   oldstart=rates[0].time;// 
   ObjectCreate(0,"Start",OBJ_VLINE,0,oldstart,0) ; 
   ObjectSetInteger(0,"Start",OBJPROP_COLOR,Green) ;
   ObjectSetInteger(0,"Start",OBJPROP_SELECTABLE,true) ;
   //------------------------------------------------------------
   SetIndexBuffer(0,CumIkvitiBuffer,INDICATOR_DATA);
   ArraySetAsSeries(CumIkvitiBuffer,true);
   //    
   int razm=0;//
   if(Symb1 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb1 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb1) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb1,0,oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
      } 
    if(Symb2 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb2 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb2) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb2,0,oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
      } 
    if(Symb3 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb3 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb3) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb3,0,oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
      }
    if(Symb4 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb4 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb4) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb4,0,oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
      }
    if(Symb5 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb5 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb5) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb5,0,oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
      }
    if(Symb6 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb6 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb6) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb6,0,oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
      }
    if(Symb7 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb7 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb7) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb7,0,oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
      }
    if(Symb8 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb8 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb8) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb8,0,oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
      }
    if(Symb9 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb9 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb9) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb9,0,oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
      }
    if(Symb10 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb10 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb10) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb10,0,oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
      }
      objdrag=true ;        
   return(0);
  }
//=================================================================================
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {//        
      datetime aaa;
      if( id == CHARTEVENT_OBJECT_DRAG && objdrag)
         {
            if (sparam == "Stop")
               {//             
                  //Print("     =============================") ;
                  aaa=oldstop-oldstart ;//   
                  oldstop=(datetime)ObjectGetInteger(0,"Stop",OBJPROP_TIME,0) ;
                  oldstart=oldstop-aaa ;
                  ObjectDelete(0,"Start") ;
                  ObjectCreate(0,"Start",OBJ_VLINE,0,oldstart,0) ; 
                  ObjectSetInteger(0,"Start",OBJPROP_COLOR,Green) ;
                  ObjectSetInteger(0,"Start",OBJPROP_SELECTABLE,true) ;
               }
            oldstart=(datetime)ObjectGetInteger(0,"Start",OBJPROP_TIME,0) ;
            //Print("    ========");
            dragen=true ;
         }
  }
//================================================================================
bool  Initialize()
   {//     
   //static bool first=true;//    
   int i,nambeval,nambeopen;
   double   openprice[];//     
   bool  flagnambopen;
      //           
         dragen=false; //first=false;
         //Print("   =====================") ;
         i=0 ;
         nambeval=ArraySize(Instrum);//     
         for(i=0;i<nambeval;i++)
           {
               ArrayResize(Instrum[i].ikviti,0,0) ;
               ArrayResize(Instrum[i].open,0,0);//        
           }
         flagnambopen=true ;
         for( i=0;i<nambeval;i++)
           {//      
              if(CopyRates(Instrum[i].Name,Period(),oldstop,oldstart,rates) <= 0)
                { Print("    ",Instrum[i].Name); return(false) ;}
              if(flagnambopen)
               {//             
                  nambeopen=ArraySize(rates) ;
                  flagnambopen=false ;
               }
              if(nambeopen != ArraySize(rates))
               {//             
                  Print("      ",Instrum[i].Name,"        ") ;
                  return(false) ;
               }
              ArrayResize(Instrum[i].open,nambeopen,0);//      
               for(int j=0 ;j<nambeopen;j++)
                  {//   .
                     Instrum[i].open[j]=rates[j].open ;
                  }
              Print("  ",Instrum[i].Name,"      =  ",nambeopen );
           }
           return(true) ;
   }
//=================================================================================================================
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   static bool first=true;//    
   if(dragen || first)  
      {//        
         first=false ;
         if( !Initialize()) return(0) ;
      }
   
   return(rates_total);
  }
//+------------------------------------------------------------------+
